Page MenuHome

Sampling Subframes not working 2.8
Closed, ResolvedPublic

Tokens
"Love" token, awarded by fin.eskimo."Party Time" token, awarded by jonathanl."Manufacturing Defect?" token, awarded by klutz."Mountain of Wealth" token, awarded by finnb.
Authored By
Remi (rlarroque), Feb 11 2019

Description

System Information
Operating system: centos
Graphics card:1080 ti

Blender Version
Broken: 2.8 8b192e1a6a5f

Short description of error
the Sampling Subframes in the flow smoke object setting doent seems to have any effect

Exact steps for others to reproduce the error
Based on the default startup or an attached .blend file (as simple as possible).
c-reate a smoke domaine from a default cube
-create a smoke flow object from a default cube
-create 3 key frame in translation
-bake different simulation in point cache with different Sampling Subframes does not change anything in the result

Event Timeline

Jacques Lucke (JacquesLucke) lowered the priority of this task from Needs Triage by Developer to Needs Information from User.Feb 12 2019, 11:06 AM

Please provide a simple .blend file that allows us to reproduce the bug more easily.

here is a simpla example from an animated object in blender

Jacques Lucke (JacquesLucke) raised the priority of this task from Needs Information from User to Confirmed, Medium.Feb 12 2019, 3:14 PM
Brecht Van Lommel (brecht) lowered the priority of this task from Confirmed, Medium to Confirmed, Low.Feb 13 2019, 5:16 PM

I need this unbroken now. My smoke flow, in an animation that is important to me, travels extremely fast and leaves completely disjointed smoke puffs in its path. Why did it get set to low priority? Did you think it will be difficult to fix?

Finn Bear (finnb) added a comment.EditedMay 9 2019, 11:52 PM

Looks like this isn't a bug. I found the following in /source/blender/blenkernel/intern/smoke.c line 3027 (after about an hour of searching)

/* Disable substeps for now, since it results in numerical instability */
totalSubsteps = 1.0f;

Does the comment still apply?

If so, how severe is it? Would it be better to cap substeps at a value like 5 or 10, rather than just 1? How long is "for now"?

Also, if you are disabling a feature, shouldn't you do it in the UI and not the kernel? That way, users wouldn't expect it to work.

@Jacques Lucke (JacquesLucke)

Any news on this? I'm also working on a simulation that requires subframe sampling and it would be great for this to work.

You can create a smoke sim in 2.79 and import it I believe. It's worth a try at least. The point data shouldn't care after it's already baked.

You are correct. It is possible to bring it from 2.79. That's what I'm doing now, but it's a much slower (and limited) workflow.

For me, I can't use 2.79 because the smoke flow object was created and edited in 2.8 only. The workflow would be a mess. Wouldn't it be better to remove the "totalSubsteps = 1.0f;" and let people use substeps at their own risk?

Actually, you were right SlyNine. I was able to append the the smoke objects from the 2.8 blend file, bake the simulation in 2.79, and import it back. Still, is this bug/kludge ever going to get fixed?

Hi @Brecht Van Lommel (brecht) and @Jacques Lucke (JacquesLucke)

I know the dev team is busy getting 2.8 ready for launch and I don't mean to nag you guys about this. But I'm a little worried this might have been forgotten. With the release candidate around the corner I would like to see this bug being addressed. As it is, it makes it pretty hard to use the smoke simulator in production with any kind of fast moving objects.

I know you are probably looking to replace the whole smoke simulator with the Mantaflow branch, but if that is not going to happen before the 2.8 release, then this should probably get at least back to how it worked in 2.79.

Would it help to bring this up to @Dalai Felinto (dfelinto) or @Ton Roosendaal (ton) attention? Do you need any more test files?
I'm not a developer, so I can't help much with the code, but I'm happy to help with anything else I can. Just let me know.

This is not going to be fixed for 2.80, sorry, there is no time for it.

Thanks for the quick reply @Brecht Van Lommel (brecht).

I understand we're so close to launch that it's too late to fix.
Would re-enabling the line @Finn Bear (finnb) mentioned be that unstable? (/source/blender/blenkernel/intern/smoke.c line 3027). It seemed to work in 2.79.

If not, I suggest the control being removed. As it is, we have a control in the flow options that doesn't do anything.

Thanks again for the all the great work on 2.8 and I look forward to seeing this bug fixed after the release so I can leave 2.79 behind.

Any plans for this to be fixed before the final since the launch has been delayed with RC2?

Glad to find this report, Having this issue on Mac OS 2.80, and also keen for a fix. Keep up the fine work!

Subframes still not working

Blender 2.80.75

From https://www.blendernation.com/2019/09/24/developer-meeting-notes-september-23-2019/:

Mantaflow is being worked on with 2.82 in mind

And Blender 2.82 is scheduled for February 13 2020.

So FWIW February 13 would be the timeline for Mantaflow to come to the rescue here.

And I'm not suggesting either waiting or fixing, I just wanted to add this datapoint since Mantaflow was mentioned.

Note also @Finn Bear (finnb) that the "Disable substeps for now" comment seems to be a red herring; it was in 2.79 as well...
https://developer.blender.org/rB1e13168183361e65e01c7613f094407780d0967e

... and @Joao Morgado (MrJomo) says above that 2.79 works.

One workaround that I was able to use with vanilla 2.8 was to:

  • Up the global Frame Rate in the Output section from 24fps to 100fps.
  • Multiply smoke Dissolve Time by 4 (I don't have "Slow" checked, not sure how Slow would affect this).
  • Multiply the Smoke Cache End frame by 4.
  • Render image 73 rather than image 19 (I tried 19*4=76 first, but 73 just happened to look better than 76)

In my case I'm not after an animation, but just a still of the smoke after it has developed.

Not sure how this would work for somebody who wants an animation of the smoke as it moves.

Question for the devs. Is there a reason why we can't revert back to 2.79's behaviour. I understand that there are some bugs in it, but for the most part it was working in 2.79. Now there's features we can't even use.
Can we just bring back the old behaviour, even with the bugs, until we get MantaFlow? Maybe it's set as an "experimental feature" .

Is there really no faster timeline for this?

Subframes are crucial for smoke simulations, which make them basically unusable until this is fixed.

Feb 2020 is a long time, and MantaFlow is such a complex project it could be delayed even further. There's no faster fix?

Hi everyone! Dalai just showed me this task and I gave it a try. Found the problem and here is how it looks now:

The subframes had simply been disabled in the code. I am just going to push this to master since there's no way to make it worse.

Thanks Sebastián. This is great! There's probably still some problems, but at least this makes the smoke simulator usable again until MantaFlow comes out.

And for context, here's where it was disabled: https://developer.blender.org/rB4494be513ac455b106b2cb9be119136a58212cd1

Comment says:

Fix smoke to render in Cycles again.
Viewport caching seems still broken, though baking works.

Note that the disabling change contained a lot more changes than just the subframes disabling, so that comment may or may not be relevant in here.

@Johan Walles (walles) I would say so as today is still part of bcon2 (on master)

Now works great in 2.81, but not working when using particles for emitting smoke :(